int GetCharSkillNumber(clsChar* pChar, int dwSkill)
{
	int i;
	for (i = 0;i < pChar->SkillCount;i++)
	{
		if (pChar->Skills[i] == dwSkill) return(i);
	}
	return(-1);
}

int GetSkillLevel(clsChar* pChar, int dwSkill)
{
	int retval = 0, i;
	for (i = 0;i < pChar->SkillCount;i++)
	{
		if (pChar->Skills[i] == dwSkill)
		{
			retval = pChar->SkillRank[i];
			break;
		}
	}
	return(retval);
}

inline void CalculateSkillAdd(clsChar* pChar, int &left, const int dwLevel, const int dwSkill, const int oldSkillLevel, const int MonsterSkill, const int dwLevel2 = 0)
{
	left -= dwLevel * (pChar->Context.ClassSkills[dwSkill] < 2 ? 2 : 1);
	if (MonsterSkill)
	{
		left += oldSkillLevel * (pChar->Context.ClassSkills[dwSkill] < 2 ? 2 : 1);
		const int oldSkillNumber = GetCharSkillNumber(pChar, dwSkill);
		if ((oldSkillNumber) != -1)
		{
			pChar->SkillRank[oldSkillNumber] = dwLevel;
			if (dwLevel2 == 5)
			{
				left--;
				if (pChar->SkillRank2[oldSkillNumber] == 5)
				{
					pChar->SkillRank[oldSkillNumber]++;
					pChar->SkillRank2[oldSkillNumber] = 0;
				}
			}
			return;
		}
	}
	pChar->Skills[pChar->SkillCount] = dwSkill;
	pChar->SkillRank[pChar->SkillCount] = dwLevel;
	if (pChar->SkillRank2[pChar->SkillCount] = dwLevel2) left--;
	mCheckOverflow(pChar->SkillCount, MAX_SKILLS, "Skill Array", "MAX_SKILLS");
	pChar->SkillCount++;
}

void CalculateSkillsAny(clsChar* pChar, int left)
{
	int temp;
	for (int i = 0;i < pChar->SkillCount;i++)
	{
		const int classskill = pChar->Context.ClassSkills[pChar->Skills[i]];
		temp = pChar->SkillRank[i];
		if (classskill < 2) temp *= 2;
		if (pChar->SkillRank2[i]) temp++;

		const int temp2 = min(pChar->Level + 3 - temp, left);
		left -= temp2;
		temp += temp2;

		if (classskill < 2)
		{
			pChar->SkillRank[i] = temp / 2;
			pChar->SkillRank2[i] = (temp % 2) * 5;
		}
		else
		{
			pChar->SkillRank[i] = temp;
		}
	}
}

void CalculateSkills(clsChar* pChar, int MonsterSkill = 0)
{
	int i, j, k, left = 0;
	int temp = 0, temp2;
	int retryd = 0;
	p<char> tempskills;
	tempskills.ptr = (char*) mallocl(Source.SkillSourceCount * sizeof(char), "CalculateSkills-tempskills");

	mGetStatic(sisave_CSA_C, sbsave_CSA_C, GetFeatNumber("Cosmopolitan"));

	mGetStatic(sisave_CSA_Me, sbsave_CSA_Me, GetRaceNumber("Mensch"));
	
	if (MonsterSkill == 1)
	{
		left = pChar->SkillCountReal;

		mGetStatic(sisave_CSA_SkL, sbsave_CSA_SkL, GetSkillNumber("Lauschen"));
		mGetStatic(sisave_CSA_SkE, sbsave_CSA_SkE, GetSkillNumber("Entdecken"));
		mGetStatic(sisave_CSA_SkS, sbsave_CSA_SkS, GetSkillNumber("Suchen"));

		mGetStatic(sisave_CSA_SkB, sbsave_CSA_SkB, GetSkillNumber("Bluffen"));
		mGetStatic(sisave_CSA_SkK, sbsave_CSA_SkK, GetSkillNumber("Konzentration"));
		mGetStatic(sisave_CSA_SkD, sbsave_CSA_SkD, GetSkillNumber("Diplomatie"));
		mGetStatic(sisave_CSA_SkEn, sbsave_CSA_SkEn, GetSkillNumber("Entfesselungsknstler"));
		mGetStatic(sisave_CSA_SkW, sbsave_CSA_SkW, GetSkillNumber("WissenArkanes"));
		mGetStatic(sisave_CSA_SkA, sbsave_CSA_SkA, GetSkillNumber("Aussphen"));

		SetMax(pChar->Context.ClassSkills[sisave_CSA_SkL], 3);
		SetMax(pChar->Context.ClassSkills[sisave_CSA_SkE], 3);
		SetMax(pChar->Context.ClassSkills[sisave_CSA_SkS], 3);

		SetMax(pChar->Context.ClassSkills[sisave_CSA_SkB], 2);
		SetMax(pChar->Context.ClassSkills[sisave_CSA_SkK], 2);
		SetMax(pChar->Context.ClassSkills[sisave_CSA_SkD], 2);
		SetMax(pChar->Context.ClassSkills[sisave_CSA_SkEn], 2);
		SetMax(pChar->Context.ClassSkills[sisave_CSA_SkW], 2);
		SetMax(pChar->Context.ClassSkills[sisave_CSA_SkA], 2);

		temp2 = 1;

		CopyMemory(tempskills, pChar->Context.ClassSkills, Source.SkillSourceCount * sizeof(char));

		goto MonsterSkillStart;
	}
	else if (MonsterSkill == 0)
	{
		pChar->SkillCount = 0;
	}

	if (MonsterSkill == 0)
	{
		left = GreaterZero(Source.CharSource[pChar->Classes[0]].Skills + pChar->Mods[3]) * 4;
		if (pChar->Race == sisave_CSA_Me && pChar->DummyChar == 0)
		{
			left += 3 + pChar->Level;
		}
	}

	for (i = 0;i < pChar->ClassCount;i++)
	{
		if (pChar->DummyClass[i]) continue;
		j = pChar->Levels[i];
		if (MonsterSkill) j -= ((int*) MonsterSkill)[i];
		else if (i == 0) j--;
		left += GreaterZero(Source.CharSource[pChar->Classes[i]].Skills + pChar->Mods[3]) * j;
		for (k = 0;k < Source.SkillSourceCount;k++)
		{
			SetMax(pChar->Context.ClassSkills[k], Source.SkillSource[k].Prob[pChar->Classes[i]]);
		}
	}

	if (FeatPresent(pChar, sisave_CSA_C, pChar->FeatCount))
	{
		p<int> CosProb;
		CosProb = (int*) mallocl(Source.SkillSourceCount * sizeof(int), "CalculateSkillsA-CosProb");
		for (j = 0;j < Source.SkillSourceCount;j++)
		{
			CosProb[j] = (pChar->Context.ClassSkills[j] < 2);
		}
		for (i = 0;i < pChar->FeatCount;i++)
		{
			if (pChar->Feats[i] == sisave_CSA_C)
			{
				if (pChar->FeatDependancy[i] <= 0)
				{
					j = AdvancedRand(pChar->Context.seeda, Source.SkillSourceCount, CosProb, sizeof(int),
						(char*) &Source.SkillSource[0].Name.buffer, sizeof(clsSkillSource),
						"Fertigkeit fr Talent Cosmopolitan whlen!", 0, 1, 0, 0);
					pChar->FeatDependancy[i] = j;
				}
				SetMax(pChar->Context.ClassSkills[pChar->FeatDependancy[i]], 3);
				CosProb[pChar->FeatDependancy[i]] = 0;
			}
		}
		CosProb.freep();
	}

	if (MonsterSkill == 0)
	{
		j = 0;
		for (i = 0;i < pChar->ClassCount;i++)
		{
			if (!pChar->DummyClass[i])
				j += Source.CharSource[pChar->Classes[i]].BonusClassSkills;
		}
		if (j)
		{
			p<int> BonusClassSkills = (int*) mallocl(Source.SkillSourceCount * sizeof(int), "ReArrangeSkills-BonusClassSkills");
			for (i = 0;i < Source.SkillSourceCount;i++)
			{
				BonusClassSkills[i] = (tempskills[i] < 2);
			}
			for (i = 0;i < j;i++)
			{
				k = AdvancedRand(pChar->Context.seeda, Source.SkillSourceCount, BonusClassSkills, sizeof(int), (char*) &Source.SkillSource[0].Name.buffer, sizeof(clsSkillSource), "Zustzliche Klassenfertigkeit whlen", 0, 1, 0, 0);
				if (k == -1)
				{
					break;
				}
				SetMax(pChar->Context.ClassSkills[k], 2);
				BonusClassSkills[k] = 0;
			}
			BonusClassSkills.freep();
		}
	}

	left += pChar->BonusSkillPointCount - pChar->BonusSkillPointCountLast;
	pChar->BonusSkillPointCountLast = pChar->BonusSkillPointCount;
	
	pChar->SkillCountReal += left;

	CopyMemory(tempskills, pChar->Context.ClassSkills, Source.SkillSourceCount * sizeof(char));

	if (pChar->Profiled)
	{
		for (i = 0;i < Source.Profiles[pChar->Profile].SkillCount;i++)
		{
			if (left == 0) break;
			const int dwProfSkill = Source.Profiles[pChar->Profile].Skills[i].Skill;
			if (RandomText) sprintf(pChar->Context.tempout, "Fertigkeit: %s: ", Source.SkillSource[dwProfSkill].Name.buffer);

			temp = max(Source.Profiles[pChar->Profile].Skills[i].MinLvl, pChar->SkillRequired[dwProfSkill]);
			temp2 = pChar->Level + 3;
			if (pChar->Context.ClassSkills[dwProfSkill] == 1)
			temp2 /= 2;
			temp2 = max(temp2, pChar->SkillRequired[dwProfSkill]);
			const int oldSkillLevel = MonsterSkill ? GetSkillLevel(pChar, Source.Profiles[pChar->Profile].Skills[i].Skill) : 0;
			if (MonsterSkill)
			{
				temp = max(temp, oldSkillLevel);
				temp2 = min(temp2, oldSkillLevel + left / (pChar->Context.ClassSkills[dwProfSkill] > 2 ? 1 : 2));
			}
			else
			{
				temp2 = min(temp2, left / (pChar->Context.ClassSkills[dwProfSkill] > 2 ? 1 : 2));
			}
			if (temp2 < temp) temp = temp2;

			temp = random(pChar->Context.seeda, temp, temp2, pChar->Context.tempout);
			
			tempskills[dwProfSkill] = 0;

			CalculateSkillAdd(pChar, left, temp, dwProfSkill, oldSkillLevel, MonsterSkill);
		}
	}

	for (i = 0;i < Source.SkillSourceCount;i++)
	{
		if (pChar->SkillRequired[i] && pChar->Context.ClassSkills[i] != 3)
		{
			if (!pChar->Context.ClassSkills[i])
			{
				qprintf("Non available Skill required\n");
				quitprog(true, pChar->CreationTemplate);
			}
			const int oldSkillLevel = MonsterSkill ? GetSkillLevel(pChar, i) : 0;

			if (oldSkillLevel >= pChar->SkillRequired[i]) continue;
			
			temp = max(oldSkillLevel, pChar->SkillRequired[i]);
			temp2 = pChar->Level + 3;
			if (pChar->Context.ClassSkills[i] < 2)
			{
				temp2 /= 2;
			}
			temp2 = min(temp2, left / (pChar->Context.ClassSkills[i] > 2 ? 1 : 2) + oldSkillLevel);
			if (temp2 < temp) temp = temp2;

			if (RandomText) sprintf(pChar->Context.tempout, "Level der bentigten Fertigkeit %s wahlen!\n", Source.SkillSource[i].Name.buffer);
			temp = random(pChar->Context.seeda, temp, temp2, pChar->Context.tempout);

			tempskills[i] = 0;

			CalculateSkillAdd(pChar, left, temp, i, oldSkillLevel, MonsterSkill);
		}
	}

MonsterSkillStart:

	for (i = 0;i < Source.SkillSourceCount;i++)
	{
		if (tempskills[i] == 3)
		{
			const int oldSkillLevel = MonsterSkill ? GetSkillLevel(pChar, i) : 0;

			if (RandomText) sprintf(pChar->Context.tempout, "Fertigkeit Maximieren (%s)", Source.SkillSource[i].Name.buffer);
			if (boolrand(pChar->Context.seeda, pChar->Context.tempout, 1, 2))
			{
				temp = min(pChar->Level + 3, left / (pChar->Context.ClassSkills[i] > 2 ? 1 : 2) + oldSkillLevel);
			}
			else
			{
				if (pChar->SkillRequired[i] > 0)
				{
					temp = pChar->SkillRequired[i];
				}
				else
				{
					temp = 1;
				}
				temp = max(temp, oldSkillLevel);

				temp2 = pChar->Level + 3;
				temp2 = min(temp2, left / (pChar->Context.ClassSkills[i] > 2 ? 1 : 2) + oldSkillLevel);
				if (temp2 < temp) temp = temp2;

				if (RandomText) sprintf(pChar->Context.tempout, "Level der wichtigen Fertigkeit %s whlen\n", Source.SkillSource[i].Name.buffer);

				for (j = 0;j < (manual ? 1 : 3);j++)
				{
					temp = random(pChar->Context.seeda, temp, temp2, pChar->Context.tempout);
				}
			}

			CalculateSkillAdd(pChar, left, temp, i, oldSkillLevel, MonsterSkill);
		}
	}

	int tries = 0;
	while (left > 0)
	{
		if (left == 1)
		{
			temp = 2;
		}
		else
		{
			if (RandomText) sprintf(pChar->Context.tempout, "Verbleibende Fertigkeitspunkte: %d\nArt der Fertigkeit whlen: 1 = Klassenfertigkeit\n", left);
			temp = boolrand(pChar->Context.seeda, pChar->Context.tempout, 1, 3) + 1;
		}

SkillRetry:
		temp2 = 0;
		for (i = 0;i < Source.SkillSourceCount;i++)
		{
			if (temp == tempskills[i])
			{
				temp2++;
			}
		}

		strcat(pChar->Context.tempout, "Fertigkeit whlen!\n");
		if (temp2 == 0)
		{
			retryd = 1;
			temp ^= 3;
			if (retryd == 0 && (temp == 2 || left != 1))
			{
				goto SkillRetry;
			}
			else
			{
				CalculateSkillsAny(pChar, left);
				return;
			}
		}
		else
		{
			retryd = 0;
		}

		pChar->Context.tempout[0] = 0;
		temp2 = 0;
		for (i = 0;i < Source.SkillSourceCount;i++)
		{
			if (tempskills[i] == temp)
			{
				temp2++;
				sprintf(pChar->Context.tempstring, "%d: %s\n", temp2, Source.SkillSource[i].Name.buffer);
				strcat(pChar->Context.tempout, pChar->Context.tempstring);
			}
		}
		j = random(pChar->Context.seeda, 1, temp2, pChar->Context.tempout);
		temp2 = 0;
		for (i = 0;i < Source.SkillSourceCount;i++)
		{
			if (tempskills[i] == temp)
			{
				temp2++;
				if (temp2 == j)
				{
					break;
				}
			}
		}

		const int oldSkillLevel = GetSkillLevel(pChar, i);
		int temp3 = 0;

		if (RandomText) sprintf(pChar->Context.tempout, "Fertigkeit Maximieren (%s)", Source.SkillSource[i].Name.buffer);
		temp2 = pChar->Level + 3;
		temp2 /= temp ^ 3;
		temp2 = min(temp2, left * temp / 2 + oldSkillLevel);
		if (boolrand(pChar->Context.seeda, pChar->Context.tempout, 2, temp))
		{
			if (pChar->Level % 2 == 0) temp3 = 5;
		}
		else if (Source.SkillSource[i].Untrained == 0 && boolrand(pChar->Context.seeda, "Nur 1 Punkt damit verfgbar", temp + 1, 1))
		{
			temp2 = temp ^ 3;
		}
		else
		{
			if (temp2 < oldSkillLevel + 1)
			{
				if (tries++ == 1000)
				{
					CalculateSkillsAny(pChar, left);
					return;
				}
				continue;
			}
			temp2 = random(pChar->Context.seeda, oldSkillLevel + 1, temp2, "Fertigkeitslevel whlen\n");
			if (temp == 1 && pChar->Level % 2 == 0 && boolrand(pChar->Context.seeda, "Halbes Level hinzufgen", 1, 1))
			{
				temp3 = 5;
			}
		}

		CalculateSkillAdd(pChar, left, temp2, i, oldSkillLevel, MonsterSkill, temp3);
		tempskills[i] = 0;
	}
}

void FinishSkills(clsChar* pChar)
{
	int* present;
	int i, j;

	present = (int*) mallocl(Source.SkillSourceCount * sizeof(int), "FinishSkills-present");
	ZeroMemory(present, Source.SkillSourceCount * sizeof(int));

	ZeroMemory(present, Source.SkillSourceCount * sizeof(int));
	for (i = 0;i < pChar->SkillCount;i++)
	{
		present[pChar->Skills[i]] = 1;
	}

	for (i = 0;i < Source.SkillSourceCount;i++)
	{
		if (present[i] == 0 && Source.SkillSource[i].Untrained)
		{
			for (j = 0;j < pChar->ClassCount;j++)
			{
				if (!pChar->DummyClass[j] && Source.SkillSource[i].Prob[pChar->Classes[j]])
				{
					mCheckOverflow(pChar->SkillCount, MAX_SKILLS, "Skill Array", "MAX_SKILLS");
					pChar->Skills[pChar->SkillCount++] = i;
					goto nexti;
				}
			}
		}
nexti:;
	}

	for (i = 0;i < pChar->SkillCount;i++)
	{
		if (Source.SkillSource[pChar->Skills[i]].ArmorMalus)
		{
			pChar->SkillMalus[i] -= Source.SkillSource[pChar->Skills[i]].ArmorMalus * pChar->FinalArmorMalus;
		}
	}

	freel(present);
}

void SummarizeSkills(clsChar* pChar)
{
	int i, j;

	CopyMemory(pChar->FinalSkillBonus, pChar->SkillBonus, MAX_SKILLS * sizeof(int));
	if (!pChar->DummyChar)
	{
		int* Synergies = (int*) mallocl(Source.SkillSourceCount * sizeof(int), "CalculateSkills-Synergies");
		ZeroMemory(Synergies, Source.SkillSourceCount * sizeof(int));
		for (i = 0;i < pChar->SkillCount;i++)
		{
			if (pChar->SkillRank[i] > 5) Synergies[pChar->Skills[i]] = 1;
		}

		for (i = 0;i < Source.SkillSourceCount;i++)
		{
			if (Synergies[i])
			{
				for (j = 1;j <= *Source.SkillSource[i].SynCode.ptr;j++)
				{
					BoostSkillA(pChar, Source.SkillSource[i].SynCode[j], 2, 0, -2);
				}
			}
		}
		freel(Synergies);
	}
	
	for (i = 0;i < pChar->SkillCount;i++)
	{
		pChar->SkillTotal[i] =
			pChar->SkillRank[i] +
			pChar->FinalSkillBonus[i] +
			pChar->Mods[Source.SkillSource[pChar->Skills[i]].Attr] +
			pChar->SkillMalus[i];
	}

}

int __cdecl ReArrangeSkillsA(const void* a, const void* b)
{
	return(strcmp(Source.SkillSource[ReArrangeFeatsA_char->Skills[*((int*) a)]].Name.buffer, Source.SkillSource[ReArrangeFeatsA_char->Skills[*((int*) b)]].Name.buffer));
}

void ReArrangeSkills(clsChar* pChar)
{
	int i;
	int* buffer = (int*) mallocl(pChar->SkillCount * sizeof(int), "ReArrangeSkills-buffer");
	int* SortSkills = (int*) mallocl(pChar->SkillCount * sizeof(int), "ReArrangeSkills-SortSkills");

	for (i = 0;i < pChar->SkillCount;i++)
	{
		SortSkills[i] = i;
	}

	ReArrangeFeatsA_char = pChar;
	qsort(SortSkills, pChar->SkillCount, sizeof(int), 
		#ifdef GCC_RUNTIME
			(int (*) (const void*, const void*))
		#endif
			&ReArrangeSkillsA);

	ReArrangeFeatsB(SortSkills, pChar->Skills, buffer, pChar->SkillCount);
	ReArrangeFeatsB(SortSkills, pChar->SkillRank, buffer, pChar->SkillCount);
	ReArrangeFeatsB(SortSkills, pChar->SkillRank2, buffer, pChar->SkillCount);
	ReArrangeFeatsB(SortSkills, pChar->SkillBonus, buffer, pChar->SkillCount);
	ReArrangeFeatsB(SortSkills, pChar->FinalSkillBonus, buffer, pChar->SkillCount);
	ReArrangeFeatsB(SortSkills, pChar->SkillMalus, buffer, pChar->SkillCount);
	ReArrangeFeatsB(SortSkills, pChar->SkillTotal, buffer, pChar->SkillCount);

	freel(buffer);
	freel(SortSkills);
}

void BoostSkillA(clsChar* pChar, int nSkill, int nLevel, int Rank, int Bonus, char* Text)
{
	int i;
	bool SkillFound = false;

	for (i = 0;i < pChar->SkillCount;i++)
	{
		if (pChar->Skills[i] == nSkill)
		{
			if (Rank)
			{
				pChar->SkillRank[i] += nLevel;
			}
			else
			{
				if (Bonus == -2)
				{
					pChar->FinalSkillBonus[i] += nLevel;
				}
				else if (Bonus >= 0)
				{
					AddBonus(pChar, &pChar->SkillBonus[i], nLevel, Bonus, Text);
				}
				else
				{
					pChar->SkillBonus[i] += nLevel;
				}
			}
			SkillFound = true;
			break;
		}
	}

	if (!SkillFound)
	{
		pChar->Skills[pChar->SkillCount] = nSkill;
		if (Rank)
		{
			pChar->SkillRank[pChar->SkillCount] = nLevel;
		}
		else
		{
			if (Bonus == -2)
			{
				pChar->FinalSkillBonus[pChar->SkillCount] += nLevel;
			}
			else if (Bonus >= 0)
			{
				AddBonus(pChar, &pChar->SkillBonus[pChar->SkillCount], nLevel, Bonus, Text);
			}
			else
			{
				pChar->SkillBonus[pChar->SkillCount] = nLevel;
			}
		}
		mCheckOverflow(pChar->SkillCount, MAX_SKILLS, "Skill Array", "MAX_SKILLS");
		pChar->SkillCount++;
	}
}
