void SetEquipSource(char** Vals, void* pEquip, void* pTempEquip, int Number, bool header)
{
	static int name, dmg1, dmg2, size, critical, criticalm, attack, type, etype, prob, armor, maxdex, malus, spell, metal, valcount;
	static int minlevelpos, rarepos, pricepos, scriptpos, forbideffectpos, amountpos;

	if (header)
	{
		name = GetValNumber(Vals, "Name", Number);
		dmg1 = GetValNumber(Vals, "Damage1", Number);
		dmg2 = GetValNumber(Vals, "Damage2", Number);
		size = GetValNumber(Vals, "Size", Number);
		critical = GetValNumber(Vals, "Critical", Number);
		criticalm = GetValNumber(Vals, "CriticalM", Number);
		attack = GetValNumber(Vals, "AttackType", Number);
		type = GetValNumber(Vals, "Type", Number);
		etype = GetValNumber(Vals, "EquipType", Number);
		prob = GetValNumber(Vals, "Prob", Number);
		armor = GetValNumber(Vals, "Armor", Number);
		maxdex = GetValNumber(Vals, "MaxDex", Number);
		malus = GetValNumber(Vals, "Malus", Number);
		spell = GetValNumber(Vals, "SpellF", Number);
		metal = GetValNumber(Vals, "Metal", Number);
		minlevelpos = GetValNumber(Vals, "MinLevel", Number);
		rarepos = GetValNumber(Vals, "Rare", Number);
		pricepos = GetValNumber(Vals, "Price", Number);
		scriptpos = GetValNumber(Vals, "Script", Number);
		forbideffectpos = GetValNumber(Vals, "ForbidEffects", Number);
		amountpos = GetValNumber(Vals, "Amount", Number);
		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		qprintf("Invalid Number of Arguments in Equipment Source Database (%s)\n", Vals[0]);
		quitprog();
	}

	ZeroMemory(pEquip, sizeof(clsEquipSource));

	((clsEquipSource*) pEquip)->Name = Vals[name];
	((clsEquipSource*) pEquip)->Damage1 = atoi(Vals[dmg1]);
	sscanf(Vals[dmg2], "W%d", &(((clsEquipSource*) pEquip)->Damage2));

	((clsEquipSource*) pEquip)->Damage3 = 0;
	((clsEquipSource*) pEquip)->Size = atoi(Vals[size]);
	((clsEquipSource*) pEquip)->Critical = atoi(Vals[critical]);
	((clsEquipSource*) pEquip)->CriticalMultiplier = atoi(Vals[criticalm]);
	((clsEquipSource*) pEquip)->AttackType = atoi(Vals[attack]);
	((clsEquipSource*) pEquip)->Type = atoi(Vals[type]);
	((clsEquipSource*) pEquip)->EquipType = atoi(Vals[etype]);
	((clsEquipSource*) pEquip)->StdProb = atoi(Vals[prob]);
	((clsEquipSource*) pEquip)->Armor = atoi(Vals[armor]);
	((clsEquipSource*) pEquip)->MaxDex = atoi(Vals[maxdex]);
	((clsEquipSource*) pEquip)->Malus = atoi(Vals[malus]);
	((clsEquipSource*) pEquip)->SpellFailure = atoi(Vals[spell]);
	((clsEquipSource*) pEquip)->Metallic = atoi(Vals[metal]);
	((clsEquipSource*) pEquip)->MinLevel = atoi(Vals[minlevelpos]);
	((clsEquipSource*) pEquip)->Rare = atoi(Vals[rarepos]);
	((clsEquipSource*) pEquip)->Price = atoi(Vals[pricepos]);
	((clsEquipSource*) pEquip)->ForbidEffects = atoi(Vals[forbideffectpos]);
	((clsEquipSource*) pEquip)->Amount = atoi(Vals[amountpos]);

	if (bnf::bnfparse(Vals[scriptpos], &(((clsEquipSource*) pEquip)->Script), &ScriptGrammar))
	{
		qprintf("Error in Character Script %s\n", Vals[name]);
		quitprog();
	}
}

void SetWProbSource(char** Vals, void* pEquip, void* pTempEquip, int Number, bool header)
{
	int i, j;
	static int specialpos;
	static int name, valcount;

	pEquip = 0;

	if (header)
	{
		for (i = 0;i < Source.CharSourceCount;i++)
		{
			if (TempSource.CharSource[i].Derrive == ";")
			{
				ClassPosition[i] = GetValNumber(Vals, Source.CharSource[i].Name.buffer, Number);
			}
			else
			{
				ClassPosition[i] = GetValNumber(Vals, TempSource.CharSource[i].Derrive.buffer, Number);
			}
		}
		for (i = 0;i < Source.RaceSourceCount;i++)
		{
			RacePosition[i] = GetValNumber(Vals, Source.RaceSource[i].Name.buffer, Number, (TempSource.RaceSource[i].SubRace == ";" ? true : false));
			if (RacePosition[i] == -1)
			{
				RacePosition[i] = GetValNumber(Vals, TempSource.RaceSource[i].SubRace.buffer, Number);
			}
		}
		name = GetValNumber(Vals, "Name", Number);
		specialpos = GetValNumber(Vals, "SpecialType", Number);
		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		qprintf("Invalid Number of Arguments in Equipment Source Database\n");
		quitprog();
	}

	for (i = 0;i < Source.EquipSourceCount;i++)
	{
		if (Source.EquipSource[i].Name == Vals[name])
		{
			Source.EquipSource[i].SpecialType = atoi(Vals[specialpos]);

			Source.EquipSource[i].Probability = (int*) mallocl(Source.CharSourceCount * sizeof(int), "SetWProbSource-Prob");
			Source.EquipSource[i].RaceProbability = (int*) mallocl(Source.RaceSourceCount * sizeof(int), "SetWProbSource-RaceProb");

			for (j = 0;j < Source.CharSourceCount;j++)
			{
				Source.EquipSource[i].Probability[j] = atoi(Vals[ClassPosition[j]]);
			}
			for (j = 0;j < Source.RaceSourceCount;j++)
			{
				Source.EquipSource[i].RaceProbability[j] = atoi(Vals[RacePosition[j]]);
			}
			return;
		}
	}
	qprintf("Could not find Equipment %s\n", Vals[0]);
	quitprog();
}

void EquipSourceExit()
{
	int i;
	for (i = 0;i < Source.EquipSourceCount;i++)
	{
		freel(Source.EquipSource[i].Script);
		if (Source.EquipSource[i].Probability)
		{
			freel(Source.EquipSource[i].Probability);
		}
		if (Source.EquipSource[i].RaceProbability)
		{
			freel(Source.EquipSource[i].RaceProbability);
		}
	}
	delete[] Source.EquipSource;
}
