void SetFeatSource(char** Vals, void* pFeat, void* pTempFeat, int Number, bool header)
{
	int i;
	static int MultiPos, name, epic, valcount, reqpos, skillpos, deppos, scriptpos, attackdeppos, feattypepos;
	static int TextPos, InbornPos, RelPos, StandardPos, ExclusivePos;

	char* TempPos;

	if (header)
	{
		for (i = 0;i < Source.CharSourceCount;i++)
		{
			ClassPosition[i] = GetValNumber(Vals, Source.CharSource[i].Name.buffer, Number, false);
		}
		MultiPos = GetValNumber(Vals, "Multi", Number);
		epic = GetValNumber(Vals, "Epic", Number);
		name = GetValNumber(Vals, "Name", Number);
		reqpos = GetValNumber(Vals, "Req", Number);
		skillpos = GetValNumber(Vals, "SkillReq", Number);
		deppos = GetValNumber(Vals, "Dep", Number);
		scriptpos = GetValNumber(Vals, "EffectScript", Number);
		attackdeppos = GetValNumber(Vals, "AttackDep", Number);
		feattypepos = GetValNumber(Vals, "FeatType", Number);
		TextPos = GetValNumber(Vals, "Text", Number);
		InbornPos = GetValNumber(Vals, "Inborn", Number);
		RelPos = GetValNumber(Vals, "Rel", Number);
		StandardPos = GetValNumber(Vals, "Standard", Number);
		ExclusivePos = GetValNumber(Vals, "Exclusive", Number);
		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		qprintf("Invalid Number of Arguments in FeatSource Database (%s)\n", Vals[0]);
		quitprog();
	}
	
	((clsFeatSource*) pFeat)->Name = Vals[name];
	((clsFeatSource*) pFeat)->Exclusive = atoi(Vals[ExclusivePos]);

	((clsFeatSource*) pFeat)->Probability = (int*) mallocl(Source.CharSourceCount * sizeof(int), "SetFeatSource-Probability");
	for (i = 0;i < Source.CharSourceCount;i++)
	{
		if (ClassPosition[i] == -1)
		{
			if (((clsFeatSource*) pFeat)->Exclusive)
			{
				((clsFeatSource*) pFeat)->Probability[i] = 0;
			}
			else
			{
				((clsFeatSource*) pFeat)->Probability[i] = atoi(Vals[ClassPosition[GetCharNumber(TempSource.CharSource[i].Derrive.buffer)]]);
			}
		}
		else
		{
			((clsFeatSource*) pFeat)->Probability[i] = atoi(Vals[ClassPosition[i]]);
		}
	}
	((clsFeatSource*) pFeat)->MultipleTimes = atoi(Vals[MultiPos]);
	((clsFeatSource*) pFeat)->Epic = atoi(Vals[epic]);
	((clsFeatSource*) pFeat)->DepType = atoi(Vals[deppos]);
	((clsFeatSource*) pFeat)->FeatType = atoi(Vals[feattypepos]);


	((clsFeatSource*) pFeat)->Inborn = atoi(Vals[InbornPos]);
	((clsFeatSource*) pFeat)->Standard = atoi(Vals[StandardPos]);

	((clsFeatSource*) pFeat)->RelCount = 0;
	if (strlen(Vals[RelPos]) > 1)
	{
		((clsFeatSource*) pFeat)->Rel = (int*) mallocl(substr_count(';', Vals[RelPos]) * sizeof(int), "SetFeatSource-Rel");
		str_replace(';', 0, Vals[RelPos]);
		TempPos = Vals[RelPos];
		while (*TempPos)
		{
			((clsFeatSource*) pFeat)->Rel[((clsFeatSource*) pFeat)->RelCount] = GetRegionNumber(TempPos);
			((clsFeatSource*) pFeat)->RelCount++;
			TempPos += strlen(TempPos) + 1;
		}
	}

	((clsFeatSource*) pFeat)->Text = Vals[TextPos];
	str_replace('_', ' ', ((clsFeatSource*) pFeat)->Text.buffer);

	((clsTempFeatSource*) pTempFeat)->ReqStr = Vals[reqpos];
	((clsTempFeatSource*) pTempFeat)->SkillStr = Vals[skillpos];

	str_replace(',', ' ', ((clsTempFeatSource*) pTempFeat)->ReqStr.buffer);
	str_replace(';', 0, ((clsTempFeatSource*) pTempFeat)->ReqStr.buffer);

	str_replace(',', ' ', ((clsTempFeatSource*) pTempFeat)->SkillStr.buffer);
	str_replace(';', 0, ((clsTempFeatSource*) pTempFeat)->SkillStr.buffer);

	((clsFeatSource*) pFeat)->AttackDep = atoi(Vals[attackdeppos]);

	if (bnf::bnfparse(Vals[scriptpos], &(((clsFeatSource*) pFeat)->Script), &ScriptGrammar))
	{
		qprintf("Error in Feat Script %s\n", Vals[name]);
		quitprog();
	}
}

void FeatSourceExit()
{
	int i;
	for (i = 0;i < Source.FeatSourceCount;i++)
	{
		freel(Source.FeatSource[i].Script);
		freel(Source.FeatSource[i].Probability);
		if (Source.FeatSource[i].RelCount)
		{
			freel(Source.FeatSource[i].Rel);
		}
	}
	delete[] Source.FeatSource;
}

char TypeName[SMALL_BUFFER_LEN];

char* GetTypeNamesA(int EquipType, int Type)
{
	if (EquipType == EQUIP_WEAPON)
	{
		if (Type == 0)
		{
			strcpy(TypeName, "EinfacheWaffen");
		}
		if (Type == 1)
		{
			strcpy(TypeName, "KriegsWaffen");
		}
		if (Type == 2)
		{
			strcpy(TypeName, "ExotischeWaffen");
		}
	}
	if (EquipType == EQUIP_ARMOR)
	{
		if (Type == 0)
		{
			strcpy(TypeName, "LeichteRstung");
		}
		if (Type == 1)
		{
			strcpy(TypeName, "MittelschwereRstung");
		}
		if (Type == 2)
		{
			strcpy(TypeName, "SchwereRstung");
		}
	}
	if (EquipType == EQUIP_SHIELD)
	{
		strcpy(TypeName, "Schilde");
	}
	return TypeName;
}

void GetTypeNames()
{
	int i, j;
	for (i = 0;i <= max(max(EQUIP_WEAPON, EQUIP_ARMOR), EQUIP_SHIELD);i++)
	{
		for (j = 0;j < (i == EQUIP_SHIELD ? 1 : 3);j++)
		{
			Source.EquipTypeFeats[i][j] = GetFeatNumber(GetTypeNamesA(i, j));
		}
	}
}