void SetRaceSource(char** Vals, void* pRace, void* pTempRace, int Number, bool header)
{
	static int name, prob, size, attack, scriptpos, modpos, valcount, rangepos, subracepos;
	static int hgmodpos, racefeatpos;
	int i;

	if (header)
	{
		name = GetValNumber(Vals, "Name", Number);
		prob = GetValNumber(Vals, "Prob", Number);
		size = GetValNumber(Vals, "Size", Number);
		attack = GetValNumber(Vals, "AttackType", Number);
		modpos = GetValNumber(Vals, "RaceMod", Number);
		scriptpos = GetValNumber(Vals, "EffectScript", Number);
		rangepos = GetValNumber(Vals, "Range", Number);
		subracepos = GetValNumber(Vals, "SubRace", Number);
		hgmodpos = GetValNumber(Vals, "HGMod", Number);
		racefeatpos = GetValNumber(Vals, "GiveFeats", Number);
		valcount = Number;
		return;
	}
		
	if (Number != valcount)
	{
		qprintf("Invalid Number of Arguments in Race Source Database (%s)\n", Vals[0]);
		quitprog();
	}

	((clsRaceSource*) pRace)->Name = Vals[name];
	((clsRaceSource*) pRace)->Probability = atoi(Vals[prob]);
	((clsRaceSource*) pRace)->Size = atoi(Vals[size]);
	((clsRaceSource*) pRace)->PreferedAttackType = atoi(Vals[attack]);
	((clsRaceSource*) pRace)->Range = atoi(Vals[rangepos]);

	str_replace(';', 0, Vals[modpos]);

	for (i = 0;i < 6;i++)
	{
		((clsRaceSource*) pRace)->RaceModBin[i] = atoi(Vals[modpos]);
		Vals[modpos] += strlen(Vals[modpos]) + 1;
	}
	

	((clsTempRaceSource*) pTempRace)->SubRace =  Vals[subracepos];
	((clsRaceSource*) pRace)->HGMod =  atoi(Vals[hgmodpos]);

	if (bnf::bnfparse(Vals[scriptpos], &(((clsRaceSource*) pRace)->Script), &ScriptGrammar) ||
		bnf::bnfparse(Vals[racefeatpos], &(((clsRaceSource*) pRace)->RaceFeats), &ScriptGrammar))
	{
		qprintf("Error in Race Script %s\n", Vals[name]);
		quitprog();
	}
}

void RaceSourceExit()
{
	int i;
	for (i = 0;i < Source.RaceSourceCount;i++)
	{
		freel(Source.RaceSource[i].Script);
		freel(Source.RaceSource[i].RaceFeats);
	}
	delete[] Source.RaceSource;
}
