void SetSkillSource(char** Vals, void* pSkill, void* pTempSkill, int Number, bool header)
{
	int i, j;
	static int name, attr, synergypos, untrainedpos, maluspos, valcount;

	if (header)
	{
		for (i = 0;i < Source.CharSourceCount;i++)
		{
			ClassPosition[i] = GetValNumber(Vals, Source.CharSource[i].Name.buffer, Number, false);
		}
		name = GetValNumber(Vals, "Name", Number);
		attr = GetValNumber(Vals, "Attr", Number);
		synergypos = GetValNumber(Vals, "Synergy", Number);
		untrainedpos = GetValNumber(Vals, "Untrained", Number);
		maluspos = GetValNumber(Vals, "ArmorMalus", Number);
		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		qprintf("Invalid Number of Arguments in SkillSource Database (%s)\n", Vals[0]);
		quitprog();
	}

	((clsSkillSource*) pSkill)->Name = Vals[name];
	((clsSkillSource*) pSkill)->Attr = atoi(Vals[attr]);
	((clsSkillSource*) pSkill)->Untrained = atoi(Vals[untrainedpos]);
	((clsSkillSource*) pSkill)->ArmorMalus = atoi(Vals[maluspos]);
	((clsTempSkillSource*) pTempSkill)->Synergy = Vals[synergypos];
	str_replace(';', 0, ((clsTempSkillSource*) pTempSkill)->Synergy.buffer);

	((clsSkillSource*) pSkill)->Prob = (int*) mallocl(Source.CharSourceCount * sizeof(int), "SetSkillSource-Prob");
	for (i = 0;i < Source.CharSourceCount;i++)
	{
		if (ClassPosition[i] == -1)
		{
			((clsSkillSource*) pSkill)->Prob[i] = 1;

			for (j = 0;j < i;j++)
			{
				if (((clsSkillSource*) pSkill)->Prob[j] == 0)
				{
					((clsSkillSource*) pSkill)->Prob[i] = 0;
					break;
				}
			}
		}
		else
		{
			((clsSkillSource*) pSkill)->Prob[i] = atoi(Vals[ClassPosition[i]]);
		}
	}
}

void SkillSourceExit()
{
	int i;
	for (i = 0;i < Source.SkillSourceCount;i++)
	{
		freel(Source.SkillSource[i].Prob);
	}
	delete[] Source.SkillSource;
}
