void str_replace(char val1, char val2, char* val, int len = 0)
{
	int i;

	if (len == 0)
	{
		len = strlen(val);
	}

	for (i = 0;i < len;i++)
	{
		if (val[i] == val1)
		{
			val[i] = val2;
		}
	}
}

void getFileName(char* savename, char* ext)
{
	while (kbhit())
	{
		getch();
	}

	do
	{
		fgets(savename, 250, stdin);
	} while (savename[0] == 0 || savename[0] == 13 || savename[0] == 10);

	str_replace(10, 0, savename);
	str_replace(13, 0, savename);
	if (stricmp(savename + strlen(savename) - strlen(ext), ext))
	{
		strcat(savename, ext);
	}
}

void saverep(char* repfile, bool force = false, CharTemplate* ForceTemplate = NULL, int Count = 1, int rename = 0);
void quitprog(bool save = true, void* pTemplate = NULL)
{
	int i, j;
	loop = 0;
	if (InitPassed && save)
	{
		saverep("error.rep", false, (CharTemplate*) pTemplate, 1, 1);
#ifndef DEBUG_RUNTIME
#ifdef BUILD_DEBUG
		qprintf("Press [D] to reproduce this character in Debug Runtime\n");

		fflush(stdin);
		i = getch();

		if ((i | 32) == 'd')
		{
			int argc = 0;;
			char** argv = NULL;

			UseReHeaderSave = true;
			CopyMemory(&ReHeaderSave, &reheader, sizeof(CharTemplate));

			Runtime(0, argc, argv);
		}
#endif
#endif
	}

	if (fDebugFile != stdout)
	{
		fclose ((FILE*) fDebugFile);
		fDebugFile = stdout;
		logverbose = -1;
		setverbose();
	}

	qprintf("Quitting due to error\n");
	SetConsoleActiveScreenBuffer(GetStdHandle(STD_OUTPUT_HANDLE));
	fflush(stdin);
	i = getchar();
	
	ZeroMemory(&j, sizeof(int));
	i /= j;
	printf("%d", i);

	return;
}

int substr_count(char val1, char* val, int len = 0)
{
	int i, num = 0;

	if (len == 0)
	{
		len = strlen(val);
	}

	for (i = 0;i < len;i++)
	{
		if (val[i] == val1)
		{
			num++;
		}
	}
	return(num);
}

unsigned int hoch(unsigned int base, unsigned int exp)
{
	unsigned int i;
	unsigned int temp = 1;
	for (i = 0;i < exp;i++)
	{
		temp *= base;
	}
	return(temp);
}

unsigned int intpart(unsigned int val, unsigned int part)
{
	val = val % (hoch(16, part));
	val = val / (hoch(16, part - 1));
	return(val);
}

int SummarizeArray(int* Array, int Number)
{
	int temp = 0, i;
	for (i = 0;i < Number;i++)
	{
		temp += Array[i];
	}
	return(temp);
}

int GreaterZero(int val)
{
	if (val > 1)
	{
		return(val);
	}
	else
	{
		return(1);
	}
}

int HighestVal(int* Array, int Number)
{
	int temp = 0, tempnum = 0, i;
	for (i = 0;i < Number;i++)
	{
		if (Array[i] > temp)
		{
			temp = Array[i];
			tempnum = i;
		}
	}
	return(tempnum);
}

double absd(double val)
{
	return((val < 0 ? - val : val));
}

int Enhence(unsigned long* seeda, int Level, int hide)
{
	int i;
	int probs[7];

	if (Level > 20 && !hide && !(manual == 1))
	{
		if (boolrand(seeda, "Artifakt?" , max(1, 55 - Level), Level - 20))
		{
			return(6);
		}
	}

	for (i = 0;i < 7;i++)
	{
		probs[i] = (int) ((double) 50000 / (((double) Level / 4 - i) * ((double) Level / 4 - i) * absd((double) Level / 4 - i) * 4 + 1));
	}

	probs[6] /= 1000;

	i = AdvancedRand(seeda, 7, probs, sizeof(int), "", 0, "Verbesserung Auswhlen!", hide);
	return(i);
}

void SecureMultiply(int* Value, int Factor)
{
	if (*Value > 500000000 / Factor)
	{
		*Value = 500000000;
	}
	else
	{
		*Value *= Factor;
	}
}

void InsertEquip(clsChar* pChar, int SourceID, int DestID, int AdjustMoney = 1)
{
	ZeroMemory(&pChar->Equipment[DestID], sizeof(clsEquip));

	pChar->Equipment[DestID].ID = SourceID;
	pChar->Equipment[DestID].Armor = Source.EquipSource[SourceID].Armor;
	pChar->Equipment[DestID].AttackType = Source.EquipSource[SourceID].AttackType;
	pChar->Equipment[DestID].Critical = Source.EquipSource[SourceID].Critical;
	pChar->Equipment[DestID].CriticalMultiplier = Source.EquipSource[SourceID].CriticalMultiplier;
	pChar->Equipment[DestID].CriticalMultiplier2 = Source.EquipSource[SourceID].CriticalMultiplier2;
	pChar->Equipment[DestID].Damage1 = Source.EquipSource[SourceID].Damage1;
	pChar->Equipment[DestID].Damage2 = Source.EquipSource[SourceID].Damage2;
	pChar->Equipment[DestID].Damage3 = Source.EquipSource[SourceID].Damage3;
	pChar->Equipment[DestID].EquipType = Source.EquipSource[SourceID].EquipType;
	pChar->Equipment[DestID].Malus = Source.EquipSource[SourceID].Malus;
	pChar->Equipment[DestID].MaxDex = Source.EquipSource[SourceID].MaxDex;
	pChar->Equipment[DestID].Metallic = Source.EquipSource[SourceID].Metallic;
	pChar->Equipment[DestID].Size = Source.EquipSource[SourceID].Size;
	pChar->Equipment[DestID].SpellFailure = Source.EquipSource[SourceID].SpellFailure;
	pChar->Equipment[DestID].Type = Source.EquipSource[SourceID].Type;

	if (AdjustMoney)
	{
		pChar->MoneyRest -= (pChar->Equipment[DestID].BaseValue = Source.EquipSource[SourceID].Price);
		if (pChar->MoneyRest < 0)
		{
			pChar->Money -= pChar->MoneyRest;
			pChar->MoneyRest = 0;
		}
	}
}

#define mCheckCharsFirst(Value) \
	int mCheckCharsI, mCheckCharsResult; \
	mCheckChars(Value)

#define mCheckChars(Value) \
	mCheckCharsResult = 0; \
	for(mCheckCharsI = 0;mCheckCharsI < pChar->ClassCount;mCheckCharsI++) \
	{ \
		if (Source.CharSource[pChar->Classes[mCheckCharsI]].Value) \
		{ \
			mCheckCharsResult = 1; \
			break; \
		} \
	} 
