int UpdateBaseBonus(int* base, int basecheck, int* full = NULL)
{
	int RetVal = 0;
	if (basecheck > *base)
	{
		RetVal = basecheck - *base;
		if (full)
		{
			*full += RetVal;
		}
		*base = basecheck;
	}

	return(RetVal);
}

void UpdateStrength(clsChar* pChar, int Strength)
{
	int mod;
	int i;
	mod = ((pChar->Attributes[0] + Strength) / 2) - (pChar->Attributes[0] / 2);
	for (i = 0;i < pChar->MAttackCount;i++)
	{
		pChar->MAttackBonus[i] += mod;
		pChar->MDamageC[i] += mod;
	}
	pChar->Attributes[0] += Strength;
	CalcMods(pChar);
}

void DoHenchmenBonuses(clsChar* pChar, clsChar* pHenchmen)
{
	UpdateBaseBonus(&pHenchmen->RWRefBase, pChar->RWRefBase, &pHenchmen->RWRef);
	UpdateBaseBonus(&pHenchmen->RWWilBase, pChar->RWWilBase, &pHenchmen->RWWil);
	UpdateBaseBonus(&pHenchmen->RWZaehBase, pChar->RWZaehBase, &pHenchmen->RWZaeh);
	int i = UpdateBaseBonus(&pHenchmen->RWEpic, pChar->RWEpic, NULL);
	pHenchmen->RWRef += i;
	pHenchmen->RWWil += i;
	pHenchmen->RWZaeh += i;
}

void DoFinalHenchmen(clsChar* pChar)
{
	int i, j;
	if (pChar->pFamiliar)
	{
		DoHenchmenBonuses(pChar, pChar->pFamiliar);

		pChar->pFamiliar->Life = max(pChar->pFamiliar->Life, pChar->Life / 2);
		pChar->pFamiliar->FinalLife = max(pChar->pFamiliar->FinalLife, pChar->FinalLife / 2);

		i = UpdateBaseBonus(&pChar->pFamiliar->GA, pChar->GA);
		i += UpdateBaseBonus(&pChar->pFamiliar->GAEpic, pChar->GAEpic);
		pChar->pFamiliar->GAMelee += i;
		pChar->pFamiliar->GAShot += i;
		for (j = 0;j < pChar->pFamiliar->MAttackCount;j++)
		{
			pChar->pFamiliar->MAttackBonus[j] += i;
		}

	}
	if (pChar->pMount) DoHenchmenBonuses(pChar, pChar->pMount);
	if (pChar->pServant) DoHenchmenBonuses(pChar, pChar->pServant);
}

void DoFamiliar(clsChar* pChar)
{
	p<int> prob;
	int i;

	if (pChar->Familiar)
	{
		if (pChar->MoneyRest >= 100 && random(pChar->Context.seeda, 0, 1, "Vertrauter?"))
		{
			pChar->MoneyRest -= 100;

			pChar->pFamiliar = new clsChar;

			mGetStatic(sisave_DH_An, sbsave_DH_An, GetMonsterTypeNumber("Animal"));
			mGetStatic(sisave_DH_IF, sbsave_DH_IF, GetFeatNumber("ImprovedFamiliar"));

			prob = (int*) mallocl(Source.MonsterSourceCount * sizeof(int), "DoFamiliar-prob");
			for (i = 0;i < Source.MonsterSourceCount;i++)
			{
				prob[i] = (Source.MonsterSource[i].Familiar[5] != ';');
				if (Source.MonsterSource[i].Type != sisave_DH_An && (!(FeatPresent(pChar, sisave_DH_IF, pChar->FeatCount))))
				{
					prob[i] = 0;
				}
			}
			i = AdvancedRand(pChar->Context.seeda, Source.MonsterSourceCount, prob, sizeof(int),
				(char*) &Source.MonsterSource[0].Name.buffer, sizeof(clsMonsterSource), "Vertrauten whlen!", 0, 1);
			prob.freep();

			ZeroMemory(pChar->Context.CTDummy, sizeof(CharTemplate));
			CopyMemory(&pChar->Context.CTDummy->BaseFrame, &pChar->CreationTemplate->BaseFrame, sizeof(structBaseFrame));
			pChar->Context.CTDummy->BaseFrame.LastMonster = -1;

			pChar->Context.CTDummy->Monster = 1;
			pChar->Context.CTDummy->MonsterName = i;
			pChar->Context.CTDummy->MaxLevel = pChar->Context.CTDummy->MinLevel = Source.MonsterSource[i].CR;

			pChar->pFamiliar->CreationTemplate = pChar->Context.CTDummy;
			CopyMemory(&pChar->pFamiliar->Context, &pChar->Context, sizeof(clsChar::clsCharContext));
			pChar->pFamiliar->HenchmenChar = 1;
			CreateChar(pChar->pFamiliar, true);

			RunScript(pChar, NULL, &pChar->pFamiliar->CharText, Source.MonsterSource[i].Familiar, Source.MonsterSource[i].Name);

			mGetStatic(sisave_DH_MB, sbsave_DH_MB, GetMonsterTypeNumber("MagicalBeast"));
			pChar->pFamiliar->MonsterType = sisave_DH_MB;

			pChar->pFamiliar->Attributes[3] = max(pChar->pFamiliar->Attributes[3], (pChar->Familiar + 1) / 2 + 5);
			CalcMods(pChar->pFamiliar);
			pChar->pFamiliar->ACRest += (pChar->Familiar + 1) / 2;
			pChar->pFamiliar->AC += (pChar->Familiar + 1) / 2;

			pChar->pFamiliar->Evasion = 2;
			mGetStatic(sisave_DH_En, sbsave_DH_En, GetSkillNumber("Entdecken"));
			mGetStatic(sisave_DH_La, sbsave_DH_La, GetSkillNumber("Lauschen"));
			BoostSkillA(pChar->pFamiliar, sisave_DH_En, 2);
			BoostSkillA(pChar->pFamiliar, sisave_DH_La, 2);

			pChar->pFamiliar->CharText += "Kann alle Fertigkeiten des Meisters nutzen wenn diese hher sind\n";
			pChar->pFamiliar->ShareSpells = 1;
			pChar->pFamiliar->EmpathicLink = 1;

			if	(pChar->Familiar >= 3)
			{
				pChar->pFamiliar->CharText += "Der Meister kann den Vertauten den Berhrungsangriff eines Zaubers durchfhren lassen, Der Vertraute muss den Meister berhren wenn der Zauber gewirkt wird\n";
			}
			if	(pChar->Familiar >= 5)
			{
				pChar->pFamiliar->SpeakWithMaster = 1;
			}
			if (pChar->Familiar >= 7)
			{
				pChar->pFamiliar->CharText += "Kann mit Tieren seiner Art sprechen\n";
			}
			if (pChar->Familiar >= 11)
			{
				pChar->pFamiliar->MR = max(pChar->pFamiliar->MR, pChar->Familiar + 5);
			}
			if (pChar->Familiar >= 13)
			{
				pChar->pFamiliar->CharText += "Der Meister kann einmal pro Tag den Vertrauten ohne Foku etc ausspben\n";
			}
		}
	}
}

void DoAnimalCompanion(clsChar* pChar)
{
	int hd;
	int num;
	int i, j;

	if (pChar->AnimalCompanion && random(pChar->Context.seeda, 0, 1, "Tiergefhrte?"))
	{
		p<int> prob, prob2, prob3, monsterNames;

		hd = random(pChar->Context.seeda, 1, pChar->AnimalCompanion, "HD Fr Tiergefhrte");
		prob = (int*) mallocl(hd * sizeof(int), "DoAnimalCompanion-prob");
		num = 0;
		while (hd)
		{
			if (random(pChar->Context.seeda, 0, 1, "Weiterer Tiergefhrte"))
			{
				prob[num] = random(pChar->Context.seeda, 1, hd, "HD Fr Tiergefhrte");
			}
			else
			{
				prob[num] = hd;
			}
			hd -= prob[num];

			num++;
		}

		prob2 = (int*) mallocl(Source.MonsterSourceCount * sizeof(int), "DoAnimalCompanion-prob2");
		prob3 = (int*) mallocl(Source.SpecialSourceCount * sizeof(int), "DoAnimalCompanion-prob3");
		monsterNames = (int*) mallocl(Source.SpecialSourceCount * sizeof(int), "DoAnimalCompanion-monsterNames");

		mGetStatic(sisave_DAC_An, sbsave_DAC_An, GetMonsterTypeNumber("Animal"));

		for (i = 0;i < num;i++)
		{
DoAnimalGetMonsterRe:
			for (j = 0;j < Source.MonsterSourceCount;j++)
			{
				if (Source.MonsterSource[j].Type == sisave_DAC_An && Source.MonsterSource[j].HD <= prob[i] && (Source.MonsterSource[j].HDMax > 0 ? Source.MonsterSource[j].HDMax : Source.MonsterSource[j].HD) >= prob[i])
				{
					prob2[j] = 1 + (Source.MonsterSource[j].Attr[3] >= 2);
				}
				else
				{
					prob2[j] = 0;
				}
			}
			monsterNames[i] = AdvancedRand(pChar->Context.seeda, Source.MonsterSourceCount, prob2, sizeof(int), (char*) &Source.MonsterSource[0].Name.buffer, sizeof(clsMonsterSource), "Tiergefhrten whlen!", 0, 1, 0, 0);
			if (monsterNames[i] == -1)
			{
				prob[num] = random(pChar->Context.seeda, 1, prob[i] - 1, "HD Zwischen 2 Tieren aufteilen!");
				prob[i] -= prob[num++];
				goto DoAnimalGetMonsterRe;
			}
		}

		pChar->AnimalCount = num;
		pChar->pAnimalCompanion = new clsChar[num];

		for (i = 0;i < num;i++)
		{

			ZeroMemory(pChar->Context.CTDummy, sizeof(CharTemplate));
			CopyMemory(&pChar->Context.CTDummy->BaseFrame, &pChar->CreationTemplate->BaseFrame, sizeof(structBaseFrame));
			pChar->Context.CTDummy->BaseFrame.LastMonster = -1;

			pChar->Context.CTDummy->Monster = 1;
			pChar->Context.CTDummy->MonsterName = monsterNames[i];

			pChar->Context.CTDummy->MonsterNameHD = prob[i];
			pChar->Context.CTDummy->MaxLevel = pChar->Context.CTDummy->MinLevel = Source.MonsterSource[monsterNames[i]].CR;

			pChar->pAnimalCompanion[i].CreationTemplate = pChar->Context.CTDummy;
			pChar->pAnimalCompanion[i].Context.seeda = pChar->Context.seeda;
			CopyMemory(&pChar->pAnimalCompanion[i].Context, &pChar->Context, sizeof(clsChar::clsCharContext));
			pChar->pAnimalCompanion[i].HenchmenChar = 1;
			CreateChar(&pChar->pAnimalCompanion[i], true);
			pChar->pAnimalCompanion->HG = Source.MonsterSource[pChar->Context.CTDummy->MonsterName].CR;

			if (pChar->pAnimalCompanion->Attributes[3] >= 2)
			{
				for (j = 0;j < Source.SpecialSourceCount;j++)
				{
					if (Source.SpecialSource[j].Type == SPECIAL_ANIMAL_TRICK)
					{
						prob3[j] = 1;
					}
					else
					{
						prob3[j] = 0;
					}
				}

				pChar->pAnimalCompanion[i].CharText += "Gelernte Tricks:\n";
				for (j = 0;j < 6;j++)
				{
					hd = AdvancedRand(pChar->Context.seeda, Source.SpecialSourceCount, prob3, sizeof(int), (char*) &Source.SpecialSource[0].Name.buffer, sizeof(clsSpecialSource), "Trick whlen!", 0, 1);
					sprintf(pChar->Context.tempout, "%s: ", Source.SpecialSource[hd].Name.buffer);
					pChar->pAnimalCompanion[i].CharText += pChar->Context.tempout;
					RunScript(&pChar->pAnimalCompanion[i], NULL, &pChar->pAnimalCompanion[i].CharText, Source.SpecialSource[hd].Script, Source.SpecialSource[hd].Name);
					prob3[hd] = 0;
				}
			}
		}
	}
}

void DoMount(clsChar* pChar)
{
	int i, j, k;

	mGetStatic(sisave_DM_Dr, sbsave_DM_Dr, GetMonsterTypeNumber("Dragon"));
	mGetStatic(sisave_DM_Me, sbsave_DM_Me, GetSizeNumber("Medium"));

	if (pChar->Mount && random(pChar->Context.seeda, 0, 1, "Paladin Mount?"))
	{
		p<int> prob;

		prob = (int*) mallocl(Source.MonsterSourceCount * sizeof(int), "DoMount-prob");
		ZeroMemory(prob, Source.MonsterSourceCount * sizeof(int));
		for (i = 0;i < Source.SpecialSourceCount;i++)
		{
			if (Source.SpecialSource[i].Type == SPECIAL_MOUNT &&
				Source.SpecialSource[i].SpellLevel <= pChar->Mount &&
				(j = GetMonsterNumber(Source.SpecialSource[i].Name.buffer)) &&
				Source.MonsterSource[j].Size - sisave_DM_Me -1 == Source.RaceSource[pChar->Race].Size)
			{
				if (Source.SpecialSource[i].SpellLevel == 1)
				{
					prob[j] = 500;
				}
				else if (Source.MonsterSource[j].Type != sisave_DM_Dr)
				{
					prob[j] = 10;
				}
				else
				{
					prob[j] = 1;
				}
			}
		}

		j = AdvancedRand(pChar->Context.seeda, Source.MonsterSourceCount, prob, sizeof(int), (char*) &Source.MonsterSource[0].Name.buffer, sizeof(clsMonsterSource), "Paladin Mount whlen!", 0, 1);
		prob.freep();
		i = Source.SpecialSource[GetSpecialNumber(Source.MonsterSource[j].Name.buffer, SPECIAL_MOUNT)].SpellLevel;
		if (pChar->Mount > 11)
		{
			k = 2 + (pChar->Mount - i - 6) / 4;
		}
		else
		{
			k = (pChar->Mount - i) / 3;
		}

		ZeroMemory(pChar->Context.CTDummy, sizeof(CharTemplate));
		CopyMemory(&pChar->Context.CTDummy->BaseFrame, &pChar->CreationTemplate->BaseFrame, sizeof(structBaseFrame));
		pChar->Context.CTDummy->BaseFrame.LastMonster = -1;

		pChar->Context.CTDummy->Monster = 1;
		pChar->Context.CTDummy->MonsterName = j;
		pChar->Context.CTDummy->MonsterNameHD = Source.MonsterSource[j].HD + 2 * (k + 1);
		pChar->Context.CTDummy->MaxLevel = pChar->Context.CTDummy->MinLevel = Source.MonsterSource[i].CR;

		pChar->pMount = new clsChar;
		pChar->pMount->CreationTemplate = pChar->Context.CTDummy;
		CopyMemory(&pChar->pMount->Context, &pChar->Context, sizeof(clsChar::clsCharContext));
		pChar->pMount->HenchmenChar = 1;
		CreateChar(pChar->pMount, true);

		pChar->pMount->Attributes[3] = max(pChar->pMount->Attributes[3], 6 + k);
		CalcMods(pChar->pMount);
		pChar->pMount->ACRest += 4 + 2 * k;
		pChar->pMount->AC += 4 + 2 * k;
		UpdateStrength(pChar->pMount, 1 + k);

		pChar->pMount->ShareSpells = 1;
		pChar->pMount->EmpathicLink = 1;
		pChar->pMount->Evasion = 2;

		if (k >= 2)
		{
			pChar->pMount->CharText += "Command: The mount's command ability is a spell-like ability that it can use at will against other creatures of its kind with";
			pChar->pMount->CharText += "fewer Hit Dice than it has itself. The mount can use this ability once per day per two levels of its paladin, and the ability";
			pChar->pMount->CharText += "functions just like the spell command (for purposes of this spell, the mount can make itself be understood by any normal";
			pChar->pMount->CharText += "animal of its kind). Since this is a spell-like ability, the mount must make a Concentration check (DC 21) if it's being ridden at";
			pChar->pMount->CharText += "the time (as in combat). If the check fails, the ability does not work that time, but it still counts against the mount's daily uses.\n";
		}

		if (k >= 3)
		{
			pChar->pMount->MR = max(pChar->pMount->MR, pChar->Mount + 5);
		}
	}
}

void DoServant(clsChar* pChar)
{
	int i, j;

	if (pChar->Servant && random(pChar->Context.seeda, 0, 1, "Servant"))
	{
		p<int> prob;

		prob = (int*) mallocl(Source.MonsterSourceCount * sizeof(int), "DoServant-prob");
		ZeroMemory(prob, Source.MonsterSourceCount * sizeof(int));
		for (i = 0;i < Source.SpecialSourceCount;i++)
		{
			if (Source.SpecialSource[i].Type == SPECIAL_SERVANT)
			{
				j = GetMonsterNumber(Source.SpecialSource[i].Name.buffer);
				prob[j] = 1;
			}
		}
		j = AdvancedRand(pChar->Context.seeda, Source.MonsterSourceCount, prob, sizeof(int), (char*) &Source.MonsterSource[0].Name.buffer, sizeof(clsMonsterSource), "Fiendish Servant whlen!", 0, 1);
		prob.freep();

		ZeroMemory(pChar->Context.CTDummy, sizeof(CharTemplate));
		CopyMemory(&pChar->Context.CTDummy->BaseFrame, &pChar->CreationTemplate->BaseFrame, sizeof(structBaseFrame));
		pChar->Context.CTDummy->BaseFrame.LastMonster = -1;

		pChar->Context.CTDummy->Monster = 1;
		pChar->Context.CTDummy->MonsterName = j;
		pChar->Context.CTDummy->MonsterNameHD = Source.MonsterSource[j].HD + 2 + (pChar->Servant - 10) / 3 * 2;
		mGetStatic(sisave_DS_Fi, sbsave_DS_Fi, GetTemplateNumber("Fiendish"));
		pChar->Context.CTDummy->MonsterNameTemplate = sisave_DS_Fi;
		pChar->Context.CTDummy->MaxLevel = pChar->Context.CTDummy->MinLevel = Source.MonsterSource[i].CR;

		pChar->pServant = new clsChar;
		pChar->pServant->CreationTemplate = pChar->Context.CTDummy;
		CopyMemory(&pChar->pServant->Context, &pChar->Context, sizeof(clsChar::clsCharContext));
		pChar->pServant->HenchmenChar = 1;
		CreateChar(pChar->pServant, true);

		pChar->pServant->Attributes[3] = max(pChar->pServant->Attributes[3], 6 + (pChar->Servant - 10) / 3);
		CalcMods(pChar->pServant);
		pChar->pServant->ACRest += 1 + (pChar->Servant - 10) / 3 * 2;
		pChar->pServant->AC += 1 + (pChar->Servant - 10) / 3 * 2;
		UpdateStrength(pChar->pServant, 1 + (pChar->Servant - 10) / 3);

		pChar->pServant->Evasion = 2;
		pChar->pServant->ShareSpells = 1;
		pChar->pServant->EmpathicLink = 1;

		if (pChar->Servant >= 13)
		{
			pChar->pServant->SpeakWithMaster = 1;
		}
		if (pChar->Servant >= 16)
		{
			pChar->pServant->CharText += "+2 auf Angriff, Fertigkeiten und RW wenn der Fiendish Servant einen Bedrohten/Verwundeten meister Schtzt\n";
		}
		if (pChar->Servant >= 19)
		{
			pChar->pServant->MR = max(pChar->pServant->MR, pChar->Servant + 5);
		}
	}
}

void DoHenchmen(clsChar* pChar)
{
	DoFamiliar(pChar);
	DoAnimalCompanion(pChar);
	DoMount(pChar);
	DoServant(pChar);
}
