#ifdef QON_INCLUDE_BNF

extern char* DoRule(char* CodePos, char* Symbol, int tCompressed, clsGrammar* pGrammar, char* tSymbolName = NULL, bool bnot = false);
extern char* pInitSymbol;

extern "C" char* pTree;
extern int nTreeSize;
extern "C" int nTreeSizeMax;
extern char* SourceBuffer;
extern unsigned long SourceFileSize;

#include "../script/scriptopt.h"

int bnfinit(char* configfile, clsGrammar* pGrammar)
{
	qprinta(2)("Reading Config\n");
	if (ReadConfig(configfile, pGrammar))
	{
		qprintf("Error Reading Config File\n");
		getchar();
		return(1);
	}

	if (InitGrammar(pGrammar, configfile))
	{
		qprintf("Error Initializing Grammar\n");
		getchar();
		return(1);
	}

	qprinta(2)("\n\n");
	return(0);
}

int bnfparse(char* Source, char** ppTree, clsGrammar* pGrammar)
{
	char NearError[96];
	qprinta(2)("Splitting Script\n");

	SourceBuffer = Source;
	SourceFileSize = strlen(Source);

	ErrorBestPos = 0;
	if (DoRule(Source, pInitSymbol, 0, pGrammar) != Source + strlen(Source))
	{
		CopyMemory(NearError, ErrorBestPos, min(95, strlen(ErrorBestPos)));
		NearError[min(95, strlen(ErrorBestPos))] = 0;
		qprintf("Content does not match Grammar near:\n\n%s\n\n%s\n\n", NearError, Source);
		return(1);
	}
	nTreeSize = OptimizeScript(&pTree, nTreeSize, pGrammar);

	qprinta(2)("Script Matches Grammar\n");

	if ((*ppTree = (char*) mallocl(nTreeSize, "bnfparse-ppTree")) == 0)
	{
		qprintf("Memmory Allocaiton Error\n");
		return(1);
	}

	CopyMemory(*ppTree, pTree, nTreeSize);

	bnfreset();

	return(0);
}

void bnfreset()
{
	nTreeSizeMax = 0;
	nTreeSize = 0;
}

int bnfexit(clsGrammar* pGrammar)
{
	if (ExitGrammar(pGrammar))
	{
		qprintf("Error Unloading Grammar\n");
		getchar();
		return(1);
	}

	freel(pGrammar->SymbolPointer);
	freel(pGrammar->lpSeperatorBytes);
	freel(pGrammar->lpComments);
	freel(pGrammar->pSymbolNames);

	return(0);
}

#endif
