#ifdef QON_INCLUDE_BNF

#ifdef GCC_RUNTIME
#include <stdio.h>
#endif

#define DEBUG BNF_DEBUG_SPLIT

extern char* pInitSymbol;

char* SourceBuffer;
unsigned long SourceFileSize;

int Space = 0;

char StrOutBuffer[65];

extern "C" char* pTree;
char* pTree;
int nTreeSize = 0;
extern "C" int nTreeSizeMax;
int nTreeSizeMax = 0;

int nTreeSizeMax2;

char AddChar[2] = " ";

int AddInt;

char* ErrorBestPos;

void AddTree(char* val, int vallen = 0)
{
	char* pOldTree;

	if (vallen == 0)
	{
		vallen = strlen(val);
	}

	if (nTreeSize + vallen >= nTreeSizeMax)
	{
		nTreeSizeMax += SMALL_BUFFER_LEN;
		nTreeSizeMax2 = max(nTreeSizeMax2, nTreeSizeMax);
		pOldTree = pTree;
		pTree = (char*) mallocl(nTreeSizeMax, "AddTree-pTree");
		pTree[0] = 0;
		if (nTreeSize)
		{
			CopyMemory(pTree, pOldTree, nTreeSize + 1);
		}
		if (pOldTree)
		{
			freel(pOldTree);
		}
	}

	CopyMemory(pTree + nTreeSize, val, vallen);
	nTreeSize += vallen;
}

void TreeSub(int SymbolID, char** SymbolPointer)
{
	AddChar[0] = 1;
	AddTree(AddChar, 1);
	AddInt = (int) SymbolPointer[SymbolID];
	AddTree((char*) &AddInt, sizeof(int));
}

void TreeReturn()
{
	AddChar[0] = 0;
	AddTree(AddChar, 1);
}

template <class T>int FindMemory(T* start, T val)
{
	int i = 1;
	while (*start)
	{
		if (*start++ == val)
		{
			return(i);
		}
		i++;
	}
	return(0);
}

void PrintFoundLine(char* SymbolStartPos, char* SymbolEndPos)
{
	char* pTemp;
	char* oBuffer;

	while (*SymbolEndPos == 13 || *SymbolEndPos == 10)
	{
		SymbolEndPos--;
	}
	
	for (pTemp = SymbolEndPos;pTemp >= SymbolStartPos;pTemp--)
	{
		if (*pTemp == 10 || *pTemp == 13)
		{
			break;
		}
	}

	if (!(oBuffer = (char*) mallocl(SymbolEndPos - pTemp + 1, "PrintFoundLine-oBuffer")))
	{
		qprintf("Memory Allocation Error\n");
		getchar();
		exit(1);
	}

	CopyMemory(oBuffer, pTemp + 1, SymbolEndPos - pTemp);
	oBuffer[SymbolEndPos - pTemp - 1] = 0;
	qprintf("\"%s\"", oBuffer);
	freel(oBuffer);
}

char* DoRule(char* CodePos, char* Symbol, int tCompressed, clsGrammar* pGrammar, char* tSymbolName, bool bnot)
{
	char *pRuleGrammar = Symbol, *pCode = CodePos, *pRet, *pTemp, *pTempAll = CodePos;
	char *pNot, *pNotTemp;
	int Compressed;

	char* SymbolName;
	int SymbolID;

	char* SeperatorStartPos = CodePos;
	char* SymbolStartPos = CodePos;

	int i;
	int CheckForComment;
	char* pComment;
	int CheckForSeperator;

	bool SyntaxCorrect;
	bool DontSkip;

	int nTreeInitSize = nTreeSize;
	int nTreeNotTemp;
	
	char prSpace[16];

	if (pCode > ErrorBestPos)
	{
		ErrorBestPos = pCode;
	}

	Space++;
	sprintf(prSpace, "%%%ds", Space * 2);

	if (bnot)
	{
		Compressed = tCompressed;
		if (!(SymbolName = (char*) mallocl(strlen(tSymbolName) + 5, "DoRule-SymbolName")))
		{
			qprintf("Memory Allocation Error\n");
			getchar();
			exit(1);
		}
		sprintf(SymbolName, "%s NOT", tSymbolName);
	}
	else
	{
		Compressed = *((int*) pRuleGrammar) | tCompressed;
		pRuleGrammar += sizeof(int);
		SymbolID = *((int*) pRuleGrammar);
		pRuleGrammar += sizeof(int);

		if (!(SymbolName = (char*) mallocl(strlen(pRuleGrammar) + 1, "DoRule-SymbolName2")))
		{
			qprintf("Memory Allocation Error\n");
			return(0);
		}
		strcpy(SymbolName, pRuleGrammar);
		pRuleGrammar += strlen(pRuleGrammar) + 1;
	}

	if (DEBUG && !tCompressed)
	{
		qprintf(prSpace, "");
		qprintf("%10d %s\n", ((int) (pCode - SourceBuffer)), SymbolName);
	}

	pNot = pCode;

	if (!tCompressed)
	{
		TreeSub(SymbolID, pGrammar->SymbolPointer);
	}

	while (*pRuleGrammar)
	{
		if (pCode >= SourceBuffer + SourceFileSize && pCode == 0)
		{
			return(0);
		}
		SyntaxCorrect = false;
		if (Compressed == 0)
		{
			CheckForComment = 1;

			while (CheckForComment)
			{
				CheckForComment = 0;

				do
				{
					CheckForSeperator = 0;
					for (i = 0;i < pGrammar->nSeperatorCount;i++)
					{
						if (*pCode == pGrammar->lpSeperatorBytes[i])
						{
							pCode++;
							CheckForSeperator = 1;
							break;
						}
					}
				} while (CheckForSeperator);

				pComment = pGrammar->lpComments;

				while (*pComment)
				{
					if (strncmp(pCode, pComment, strlen(pComment)) == 0)
					{
						pComment += strlen(pComment) + 1;
						CheckForComment = 1;

						while (strncmp(pCode++ - strlen(pComment) + 1, pComment, strlen(pComment)) != 0) {}
					}
					else
					{
						pComment += strlen(pComment) + 1;
					}
					pComment += strlen(pComment) + 1;
				}
			}
		}

		if (*((int*) pRuleGrammar) == G_LINK)
		{
			if ((char*) *((int*) (pRuleGrammar + sizeof(int))))
			{
				pRet = DoRule(pCode, (char*) *((int*) (pRuleGrammar + sizeof(int))), Compressed, pGrammar);
				SyntaxCorrect = (pRet > 0);
				if (pRet) {pCode = pRet;}
			}
			else
			{
				if (*pCode == '_')
				{
					AddTree(" ", 1);
				}
				else
				{
					AddTree(pCode, 1);
				}
				pCode++;
				SyntaxCorrect = true;
			}
			pRuleGrammar += 2 * sizeof(int);
		}
		else if (*((int*) pRuleGrammar) == G_GROUP)
		{
			pRet = DoRule(pCode, (char*) *((int*) (pRuleGrammar + sizeof(int))), Compressed, pGrammar);
			if (pRet) {pCode = pRet;}

			SyntaxCorrect = (pRet > 0);

			pRuleGrammar += 2 * sizeof(int);
		}
		else if (*((int*) pRuleGrammar) == G_OPT)
		{
			pRet = DoRule(pCode, (char*) *((int*) (pRuleGrammar + sizeof(int))), Compressed, pGrammar);
			if (pRet)
			{
				pCode = pRet;
			}
			pRuleGrammar += 2 * sizeof(int);
			SyntaxCorrect = true;
		}
		else if (*((int*) pRuleGrammar) == G_REP)
		{
			do
			{
				pTemp = pCode;
				pRet = DoRule(pCode, (char*) *((int*) (pRuleGrammar + sizeof(int))), Compressed, pGrammar);
				if (pRet) {pCode = pRet;}
			} while (pRet && pRet != pTemp);
			pRuleGrammar += 2 * sizeof(int);
			SyntaxCorrect = true;
		}
		else if (*((int*) pRuleGrammar) == G_STRING)
		{
			SyntaxCorrect = true;
			i = min(*((int*) (pRuleGrammar + sizeof(int))), 64);
			CopyMemory(StrOutBuffer, (void*) (pRuleGrammar + 2 * sizeof(int)), i);
			StrOutBuffer[i] = 0;
			
			for (i = 0;i < (*((int*) (pRuleGrammar + sizeof(int))));i++)
			{
				if (!pGrammar->CaseSensitive ? ucase(*(pRuleGrammar + 2 * sizeof(int) + i)) != ucase(*(pCode + i)) : *(pRuleGrammar + 2 * sizeof(int) + i) != *(pCode + i))
				{
					SyntaxCorrect = false;
					break;
				}
			}
			if (SyntaxCorrect)
			{
				pCode += *((int*) (pRuleGrammar + sizeof(int)));
				if (DEBUG && !tCompressed)
				{
					qprintf(prSpace, "");
					qprintf("%5s%10d FOUND \"%s\"\n", "", (pCode - SourceBuffer), StrOutBuffer);
				}
				AddTree(StrOutBuffer);
			}
			pRuleGrammar += *((int*) (pRuleGrammar + sizeof(int))) + 2 * sizeof(int);
		}
		else if (*((int*) pRuleGrammar) == G_NOT)
		{
			pRuleGrammar += sizeof(int);

			pNotTemp = pCode;
			pCode = pNot;

			nTreeNotTemp = nTreeSize;
			pTemp = DoRule(pCode, pRuleGrammar, Compressed, pGrammar, SymbolName, true);
			nTreeSize = nTreeNotTemp;
			pTree[nTreeSize] = 0;
			SyntaxCorrect = (pTemp != pNotTemp);
			pRuleGrammar = SkipRule(pRuleGrammar);

			if (SyntaxCorrect) {pCode = pNotTemp;}
		}
		else if (*((int*) pRuleGrammar) == G_SEP)
		{
			pRuleGrammar += sizeof(int);
			pNot = pCode;
			SyntaxCorrect = true;
			SeperatorStartPos = pCode;
		}
		else if (*((int*) pRuleGrammar) == G_OR)
		{
			pRuleGrammar += sizeof(int);
			if (!DontSkip)
			{
				pRuleGrammar = SkipRule(pRuleGrammar);
			}
			SyntaxCorrect = true;
		}
		else if (*((int*) pRuleGrammar) == G_END)
		{
			goto EndFound;
		}
		else
		{
			qprintf("Internal Error\n");
			getchar();
			exit(1);
		}
		DontSkip = false;
		if (!SyntaxCorrect)
		{
			if (!(*((int*) pRuleGrammar) == G_OR))
			{
				if (DEBUG && !tCompressed)
				{
					qprintf(prSpace, "");
					qprintf("%10d FAILED %s\n", (int) (pCode - SourceBuffer), SymbolName);
				}

				nTreeSize = nTreeInitSize;
				pTree[nTreeSize] = 0;

				Space--;
				freel(SymbolName);
				return(0);
			}
			DontSkip = true;
		}
	}
EndFound:
	if (DEBUG && !tCompressed)
	{
		qprintf(prSpace, "");
		if (pCode != pTempAll)
		{
			qprintf("%10d FOUND %s:     ", (int) (pCode - SourceBuffer), SymbolName);
			PrintFoundLine(SymbolStartPos, pCode);
			qprintf("\n");
		}
		else
		{
			qprintf("%10d SKIP  %s\n", (int) (pCode - SourceBuffer), SymbolName);
		}
	}

	if (pCode != pTempAll)
	{
		if (!tCompressed)
		{
			TreeReturn();
		}
	}
	else
	{
		nTreeSize = nTreeInitSize;
		pTree[nTreeSize] = 0;
	}

	Space--;
	freel(SymbolName);
	return(pCode);
}

int SplitFile(char* FileName, clsGrammar* pGrammar)
{
	int i;

	char* NewFileName;

	qprintf("Opening Source File\n");
	if (!(SourceFileSize = ReadFileToBuffer(FileName, &SourceBuffer)))
	{
		qprintf("Error loading Source File\n");
		return(1);
	}

	qprintf("Splitting Source file\n");

	if (DoRule(SourceBuffer, pInitSymbol, 0, pGrammar) != SourceBuffer + SourceFileSize)
	{
		qprintf("Content does not match Grammar\n");
		return(1);
	}
	qprintf("Content Matches Grammar\n");

	nTreeSize = OptimizeScript(&pTree, nTreeSize, pGrammar);

	if ((NewFileName = (char*) mallocl(strlen(FileName) + 5, "SplitFile-NewFileName")) == 0)
	{
		qprintf("Memory Allocation Error\n");
		return(1);
	}
	strcpy(NewFileName, FileName);
	for (i = strlen(NewFileName) - 1;i > 0;i--)
	{
		if (NewFileName[i] == '.')
		{
			break;
		}
	}
	if (i == 0)
	{
		i = strlen(NewFileName);
	}
	NewFileName[i] = 0;
	strcat(NewFileName, ".kfa");

	qprintf("Writing Output to %s\n", NewFileName);

	freel(NewFileName);

	nTreeSize = 0;
	
	qprinta(2)("Freeing Memory\n");
	freel(SourceBuffer);

	qprinta(2)("Finished\n");
	return(0);
}

#undef DEBUG

#endif